/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of PKCS10.xs. Do not edit this file, edit PKCS10.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "PKCS10.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>
#include <stdlib.h>

#include <openssl/asn1.h>
#include <openssl/pem.h>
#include <openssl/x509v3.h>
#include <openssl/err.h>
#include <openssl/rand.h>

#include "ppport.h"

#if OPENSSL_VERSION_NUMBER < 0x10000000L
#define EVP_PKEY_base_id(pkey) EVP_PKEY_type((pkey)->type)
#endif
#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined LIBRESSL_VERSION_NUMBER
#define EVP_PKEY_get0_RSA(pkey) ((pkey)->pkey.rsa)
#define EVP_PKEY_get0_DSA(pkey) ((pkey)->pkey.dsa)
#if( !defined OPENSSL_NO_EC || defined LIBRESSL_VERSION_NUMBER)
#define EVP_PKEY_get0_EC_KEY(pkey) ((pkey)->pkey.ec)
#endif
#endif

typedef struct
{
    X509_REQ* req;
    EVP_PKEY *pk;
    RSA **rsa;
    STACK_OF(X509_EXTENSION) *exts;
} pkcs10Data;

typedef struct
{
    RSA* rsa;
    int padding;
    int hashMode;
} Crypt__OpenSSL__RSA; 

#define PACKAGE_NAME "Crypt::OpenSSL::PKCS10"
#define PACKAGE_CROAK(p_message) croak("%s", (p_message))
#define CHECK_NEW(p_var, p_size, p_type) \
  if (New(0, p_var, p_size, p_type) == NULL) \
    { PACKAGE_CROAK("unable to alloc buffer"); }

//int add_ext_raw(STACK_OF(X509_REQUEST) *sk, int nid, unsigned char *value, int length);
//int add_ext(STACK_OF(X509_REQUEST) *sk, int nid, char *value);
X509_NAME *parse_name(char *str, long chtype, int multirdn); 

/*
 * subject is expected to be in the format /type0=value0/type1=value1/type2=...
 * where characters may be escaped by \
 */
X509_NAME *parse_name(char *subject, long chtype, int multirdn)
	{
	size_t buflen = strlen(subject)+1; /* to copy the types and values into. due to escaping, the copy can only become shorter */
	char *buf = OPENSSL_malloc(buflen);
	size_t max_ne = buflen / 2 + 1; /* maximum number of name elements */
	const char **ne_types = OPENSSL_malloc(max_ne * sizeof (char *));
	char **ne_values = OPENSSL_malloc(max_ne * sizeof (char *));
	int *mval = OPENSSL_malloc (max_ne * sizeof (int));

	char *sp = subject, *bp = buf;
	int i, ne_num = 0;

	X509_NAME *n = NULL;

	if (!buf || !ne_types || !ne_values || !mval)
		{
		croak("malloc error\n");
		goto error;
		}	

	if (*subject != '/')
		{
		croak("Subject does not start with '/'.\n");
		goto error;
		}
	sp++; /* skip leading / */

	/* no multivalued RDN by default */
	mval[ne_num] = 0;

	while (*sp)
		{
		/* collect type */
		ne_types[ne_num] = bp;
		while (*sp)
			{
			if (*sp == '\\') /* is there anything to escape in the type...? */
				{
				if (*++sp)
					*bp++ = *sp++;
				else	
					{
					croak("escape character at end of string\n");
					goto error;
					}
				}	
			else if (*sp == '=')
				{
				sp++;
				*bp++ = '\0';
				break;
				}
			else
				*bp++ = *sp++;
			}
		if (!*sp)
			{
			croak("end of string encountered while processing type of subject name element #%d\n", ne_num);
			goto error;
			}
		ne_values[ne_num] = bp;
		while (*sp)
			{
			if (*sp == '\\')
				{
				if (*++sp)
					*bp++ = *sp++;
				else
					{
					croak("escape character at end of string\n");
					goto error;
					}
				}
			else if (*sp == '/')
				{
				sp++;
				/* no multivalued RDN by default */
				mval[ne_num+1] = 0;
				break;
				}
			else if (*sp == '+' && multirdn)
				{
				/* a not escaped + signals a mutlivalued RDN */
				sp++;
				mval[ne_num+1] = -1;
				break;
				}
			else
				*bp++ = *sp++;
			}
		*bp++ = '\0';
		ne_num++;
		}

	if (!(n = X509_NAME_new()))
		goto error;

	for (i = 0; i < ne_num; i++)
		{
		if (!*ne_values[i])
			{
			croak("No value provided for Subject Attribute %s, skipped\n", ne_types[i]);
			continue;
			}

		if (!X509_NAME_add_entry_by_txt(n, ne_types[i], chtype, (unsigned char*)ne_values[i], -1,-1,mval[i]))
			goto error;
		}

	OPENSSL_free(mval);
	OPENSSL_free(ne_values);
	OPENSSL_free(ne_types);
	OPENSSL_free(buf);
	return n;

	error:
	X509_NAME_free(n);
	if (ne_values)
		OPENSSL_free(ne_values);
	if (ne_types)
		OPENSSL_free(ne_types);
	if (buf)
		OPENSSL_free(buf);
    if (mval)
	    OPENSSL_free(mval);
	return NULL;
}

/* Add extension using V3 code: we can set the config file as NULL
 * because we wont reference any other sections.
 */

int add_ext(STACK_OF(X509_EXTENSION) *sk, X509_REQ *req, int nid, char *value)
	{
	X509_EXTENSION *ex;
	X509V3_CTX v3ctx;
	X509V3_set_ctx(&v3ctx, NULL, NULL, req, NULL, 0);
	ex = X509V3_EXT_conf_nid(NULL, &v3ctx, nid, value);
	if (!ex)
		return 0;
	sk_X509_EXTENSION_push(sk, ex);

	return 1;
	}

/*  Add an extention by setting the raw ASN1 octet string.
 */
int add_ext_raw(STACK_OF(X509_EXTENSION) *sk, int nid, char *value, int length)
	{
	X509_EXTENSION *ex;
	ASN1_STRING *asn;

	asn = ASN1_STRING_type_new(V_ASN1_OCTET_STRING);
	ASN1_OCTET_STRING_set(asn, (unsigned char *) value, length);

	ex = X509_EXTENSION_create_by_NID(NULL, nid, 0, asn);
	if (!ex)
		return 0;
	sk_X509_EXTENSION_push(sk, ex);

	return 1;
	}


SV* make_pkcs10_obj(SV* p_proto, X509_REQ* p_req, EVP_PKEY* p_pk, STACK_OF(X509_EXTENSION)* p_exts, RSA **p_rsa)
{
	pkcs10Data* pkcs10;

	CHECK_NEW(pkcs10, 1, pkcs10Data);
	pkcs10->req = p_req;
	pkcs10->pk = p_pk;
	pkcs10->exts = p_exts;
	pkcs10->rsa = p_rsa;

	return sv_bless(
		newRV_noinc(newSViv((IV) pkcs10)),
		(SvROK(p_proto) ? SvSTASH(SvRV(p_proto)) : gv_stashsv(p_proto, 1)));
}

/* stolen from OpenSSL.xs */
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
long bio_write_cb(struct bio_st *bm, int m, const char *ptr, size_t len, int l, long x, int y, size_t *processed) {
#else
long bio_write_cb(struct bio_st *bm, int m, const char *ptr, int len, long x, long y) {
#endif
        if (m == BIO_CB_WRITE) {
                SV *sv = (SV *) BIO_get_callback_arg(bm);
                sv_catpvn(sv, ptr, len);
        }

        if (m == BIO_CB_PUTS) {
                SV *sv = (SV *) BIO_get_callback_arg(bm);
                len = strlen(ptr);
                sv_catpvn(sv, ptr, len);
        }

        return len;
}

static BIO* sv_bio_create(void) {

        SV *sv = newSVpvn("",0);

	/* create an in-memory BIO abstraction and callbacks */
        BIO *bio = BIO_new(BIO_s_mem());

#if OPENSSL_VERSION_NUMBER >= 0x30000000L
        BIO_set_callback_ex(bio, bio_write_cb);
#else
        BIO_set_callback(bio, bio_write_cb);
#endif
        BIO_set_callback_arg(bio, (void *)sv);

        return bio;
}

static BIO *sv_bio_create_file(SV *filename)
{
        STRLEN l;

        return BIO_new_file(SvPV(filename, l), "wb");
}

static SV* sv_bio_final(BIO *bio) {

	SV* sv;

	BIO_flush(bio);
	sv = (SV *)BIO_get_callback_arg(bio);
	BIO_free_all(bio);

	if (!sv) sv = &PL_sv_undef;

	return sv;
}

/*
 * subject is expected to be in the format /type0=value0/type1=value1/type2=...
 * where characters may be escaped by \
 */
static int build_subject(X509_REQ *req, char *subject, unsigned long chtype, int multirdn)
	{
	X509_NAME *n;

	if (!(n = parse_name(subject, chtype, multirdn)))
		return 0;

	if (!X509_REQ_set_subject_name(req, n))
		{
		X509_NAME_free(n);
		return 0;
		}
	X509_NAME_free(n);
	return 1;
}

#line 322 "PKCS10.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 466 "PKCS10.c"

XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, keylen = 1024");
    {
	SV *	class = ST(0)
;
	int	keylen;
#line 353 "PKCS10.xs"
	X509_REQ *x;
	EVP_PKEY *pk;
    char *classname = SvPVutf8_nolen(class);

#line 483 "PKCS10.c"
	SV *	RETVAL;

	if (items < 2)
	    keylen = 1024;
	else {
	    keylen = (int)SvIV(ST(1))
;
	}
#line 358 "PKCS10.xs"
	//CRYPTO_mem_ctrl(CRYPTO_MEM_CHECK_ON);
    if (!RAND_status())
        printf("Warning: generating random key material may take a long time\n"
                   "if the system has a poor entropy source\n");

	if ((x=X509_REQ_new()) == NULL)
		croak ("%s - can't create req", classname);
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
    pk = EVP_RSA_gen(keylen);
#elif OPENSSL_VERSION_NUMBER <= 0x10000000L
    RSA *rsa;
	if ((pk=EVP_PKEY_new()) == NULL)
		croak ("%s - can't create PKEY", classname);

	rsa=RSA_generate_key(keylen, RSA_F4, NULL, NULL);
	if (!EVP_PKEY_assign_RSA(pk,rsa))
		croak ("%s - EVP_PKEY_assign_RSA", classname);
#else
    RSA *rsa = RSA_new();
    BIGNUM *bne = BN_new();
    if (bne == NULL)
		croak ("%s - BN_new failed", classname);

    if (BN_set_word(bne, RSA_F4) != 1)
		croak ("%s - BN_set_word failed", classname);

	if ((pk=EVP_PKEY_new()) == NULL)
		croak ("%s - can't create PKEY", classname);

    if (!RSA_generate_key_ex(rsa, keylen, bne, NULL))
		croak ("%s - RSA_generate_key_ex failed", classname);

	if (!EVP_PKEY_assign_RSA(pk,rsa))
		croak ("%s - EVP_PKEY_assign_RSA", classname);
#endif
	X509_REQ_set_pubkey(x,pk);
	X509_REQ_set_version(x,0L);
	if (!X509_REQ_sign(x,pk,EVP_sha256()))
		croak ("%s - X509_REQ_sign failed", classname);

	RETVAL = make_pkcs10_obj(class, x, pk, NULL, NULL);

#line 535 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pkcs10Data *	pkcs10;
#line 408 "PKCS10.xs"
	//BIO *bio_err;

#line 556 "PKCS10.c"

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 411 "PKCS10.xs"
	//bio_err=BIO_new_fp(stderr, BIO_NOCLOSE);
	if (pkcs10->pk)   EVP_PKEY_free(pkcs10->pk); pkcs10->pk = 0;
	if (pkcs10->rsa) *pkcs10->rsa = 0;
	if (pkcs10->req)  X509_REQ_free(pkcs10->req); pkcs10->req = 0;
	Safefree(pkcs10);
	CRYPTO_cleanup_all_ex_data();
	/*CRYPTO_mem_leaks(bio_err);
	BIO_free(bio_err);*/
#line 573 "PKCS10.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10__new_from_rsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10__new_from_rsa)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, p_rsa, priv");
    {
	SV *	class = ST(0)
;
	SV *	p_rsa = ST(1)
;
	SV *	priv = ST(2)
;
#line 427 "PKCS10.xs"
	Crypt__OpenSSL__RSA	*rsa;
	char *keyString;
	STRLEN keylen;
	BIO *bio;
	X509_REQ *x;
	EVP_PKEY *pk;
	char *classname = SvPVutf8_nolen(class);

#line 602 "PKCS10.c"
	SV *	RETVAL;
#line 437 "PKCS10.xs"
	// Get the private key and save it in memory
	keyString = SvPV(priv, keylen);
	bio = BIO_new_mem_buf(keyString, keylen);
	if (bio == NULL) {
		croak ("Bio is null **** \n");
	}

	// Create the PrivateKey as EVP_PKEY
	pk = PEM_read_bio_PrivateKey(bio, NULL, 0, NULL);
	if (pk == NULL) {
		croak("Failed operation error code %d\n", errno);
	}

	if ((x=X509_REQ_new()) == NULL)
		croak ("%s - can't create req", classname);

	rsa = (Crypt__OpenSSL__RSA	*) SvIV(SvRV(p_rsa));
	X509_REQ_set_pubkey(x,pk);
	X509_REQ_set_version(x,0L);
	if (!X509_REQ_sign(x,pk,EVP_sha256()))
		croak ("%s - X509_REQ_sign", classname);

	RETVAL = make_pkcs10_obj(class, x, pk, NULL, &rsa->rsa);

#line 629 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_sign)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    {
	pkcs10Data *	pkcs10;
#line 470 "PKCS10.xs"
#line 646 "PKCS10.c"
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 472 "PKCS10.xs"
	RETVAL = X509_REQ_sign(pkcs10->req,pkcs10->pk,EVP_sha256());
	if (!RETVAL)
		croak ("X509_REQ_sign");

#line 661 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_pubkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_pubkey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    {
	pkcs10Data *	pkcs10;
#line 484 "PKCS10.xs"
	EVP_PKEY *pkey;
	BIO *bio;
	int type;

#line 682 "PKCS10.c"
	SV *	RETVAL;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 490 "PKCS10.xs"
	pkey = X509_REQ_get_pubkey(pkcs10->req);
	bio  = sv_bio_create();

	if (pkey == NULL) {

		BIO_free_all(bio);
		EVP_PKEY_free(pkey);
		croak("Public Key is unavailable\n");
	}

	type = EVP_PKEY_base_id(pkey);
	if (type == EVP_PKEY_RSA) {
		PEM_write_bio_PUBKEY(bio, pkey);
	} else if (type == EVP_PKEY_DSA) {
		PEM_write_bio_PUBKEY(bio, pkey);
#ifndef OPENSSL_NO_EC
	} else if ( type == EVP_PKEY_EC ) {
		PEM_write_bio_PUBKEY(bio, pkey);
#endif
	} else {

		BIO_free_all(bio);
		EVP_PKEY_free(pkey);
		croak("Wrong Algorithm type\n");
	}
	EVP_PKEY_free(pkey);

	RETVAL = sv_bio_final(bio);

#line 721 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_pubkey_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_pubkey_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    {
	pkcs10Data *	pkcs10;
#line 527 "PKCS10.xs"
        EVP_PKEY *pkey;
	int type;

#line 741 "PKCS10.c"
	char *	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 531 "PKCS10.xs"
        RETVAL=NULL;
        pkey = X509_REQ_get_pubkey(pkcs10->req);

        if(!pkey)
            XSRETURN_UNDEF;

        type = EVP_PKEY_base_id(pkey);
        if (type == EVP_PKEY_DSA) {
            RETVAL="dsa";

        } else if (type == EVP_PKEY_RSA) {
            RETVAL="rsa";
#ifndef OPENSSL_NO_EC
        } else if ( type == EVP_PKEY_EC ) {
            RETVAL="ec";
#endif
        }

#line 770 "PKCS10.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_req); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_req)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "pkcs10, ...");
    {
	pkcs10Data *	pkcs10;
#line 561 "PKCS10.xs"
	BIO *bio;

#line 791 "PKCS10.c"
	SV *	RETVAL;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 564 "PKCS10.xs"
	if((ix != 1 && items > 1) || (ix == 1 && items != 2))
		croak("get_pem_req illegal/missing args");
	if(items > 1) {
		bio = sv_bio_create_file(ST(1));
	} else {
		bio = sv_bio_create();
	}

	/* get the certificate back out in a specified format. */

	if(!PEM_write_bio_X509_REQ(bio,pkcs10->req))
		croak ("PEM_write_bio_X509_REQ");

	RETVAL = sv_bio_final(bio);

#line 816 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_pk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_get_pem_pk)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "pkcs10, ...");
    {
	pkcs10Data *	pkcs10;
#line 591 "PKCS10.xs"
	BIO *bio;

#line 836 "PKCS10.c"
	SV *	RETVAL;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 594 "PKCS10.xs"
	if((ix != 1 && items > 1) || (ix == 1 && items != 2))
		croak("get_pem_pk illegal/missing args");
	if(items > 1) {
		bio = sv_bio_create_file(ST(1));
	} else {
		bio = sv_bio_create();
	}

    if(!pkcs10->pk)
            croak ("Private key doesn't exist");

	/* get the certificate back out in a specified format. */

	if(!PEM_write_bio_PrivateKey(bio,pkcs10->pk,NULL,NULL,0,NULL,NULL))
		croak ("%s - PEM_write_bio_PrivateKey", (char *) pkcs10->pk);

	RETVAL = sv_bio_final(bio);

#line 864 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_set_subject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_set_subject)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkcs10, subj_SV, utf8 = 0");
    {
	pkcs10Data *	pkcs10;
	SV*	subj_SV = ST(1)
;
	int	utf8;
#line 622 "PKCS10.xs"
	char* subj;
	STRLEN subj_length;

#line 887 "PKCS10.c"
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;

	if (items < 3)
	    utf8 = 0;
	else {
	    utf8 = (int)SvIV(ST(2))
;
	}
#line 626 "PKCS10.xs"
	subj = SvPV(subj_SV, subj_length);

	RETVAL = build_subject(pkcs10->req, subj, utf8 ? MBSTRING_UTF8 : MBSTRING_ASC, 0);
	if (!RETVAL)
		croak ("build_subject");

#line 911 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_ext)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkcs10, nid = NID_key_usage, ext_SV");
    {
	pkcs10Data *	pkcs10;
	int	nid;
	SV*	ext_SV = ST(2)
;
#line 642 "PKCS10.xs"
	char* ext;
	STRLEN ext_length;

#line 934 "PKCS10.c"
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;

	if (items < 2)
	    nid = NID_key_usage;
	else {
	    nid = (int)SvIV(ST(1))
;
	}
#line 646 "PKCS10.xs"
	ext = SvPV(ext_SV, ext_length);

	if(!pkcs10->exts)
		pkcs10->exts = sk_X509_EXTENSION_new_null();

	RETVAL = add_ext(pkcs10->exts, pkcs10->req, nid, ext);
	if (!RETVAL)
		croak ("add_ext key_usage: %d, ext: %s", nid, ext);

#line 961 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_custom_ext_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_custom_ext_raw)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pkcs10, oid_SV, ext_SV");
    {
	pkcs10Data *	pkcs10;
	SV*	oid_SV = ST(1)
;
	SV*	ext_SV = ST(2)
;
#line 665 "PKCS10.xs"
	char* oid;
	char* ext;
	STRLEN ext_length;
	int nid;

#line 987 "PKCS10.c"
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 671 "PKCS10.xs"
	oid = SvPV(oid_SV, ext_length);
	ext = SvPV(ext_SV, ext_length);

  	if(!pkcs10->exts)
		pkcs10->exts = sk_X509_EXTENSION_new_null();

	if ((nid = OBJ_create(oid, oid, oid)) == NID_undef)
        croak ("add_custom_ext: OBJ_create() for OID %s failed", oid);
	RETVAL = add_ext_raw(pkcs10->exts, nid, ext, ext_length);

	if (!RETVAL)
		croak ("add_custom_ext_raw oid: %s, ext: %s", oid, ext);

#line 1011 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_custom_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_custom_ext)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pkcs10, oid_SV, ext_SV");
    {
	pkcs10Data *	pkcs10;
	SV*	oid_SV = ST(1)
;
	SV*	ext_SV = ST(2)
;
#line 695 "PKCS10.xs"
	char* oid;
	char* ext;
	STRLEN ext_length;
	int nid;

#line 1037 "PKCS10.c"
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 701 "PKCS10.xs"
	oid = SvPV(oid_SV, ext_length);
	ext = SvPV(ext_SV, ext_length);

	if(!pkcs10->exts)
		pkcs10->exts = sk_X509_EXTENSION_new_null();

	if ((nid = OBJ_create(oid, oid, oid)) == NID_undef)
        croak ("add_custom_ext_raw: OBJ_create() for OID %s failed", oid);
	X509V3_EXT_add_alias(nid, NID_netscape_comment);
	RETVAL = add_ext(pkcs10->exts, pkcs10->req, nid, ext);

	if (!RETVAL)
		croak ("add_custom_ext oid: %s, ext: %s", oid, ext);

#line 1062 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_ext_final); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_add_ext_final)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    {
	pkcs10Data *	pkcs10;
	int	RETVAL;
	dXSTARG;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 723 "PKCS10.xs"
	if(pkcs10->exts) {
	RETVAL = X509_REQ_add_extensions(pkcs10->req, pkcs10->exts);

	if (!RETVAL)
		croak ("X509_REQ_add_extensions");

	if(pkcs10->exts)
		sk_X509_EXTENSION_pop_free(pkcs10->exts, X509_EXTENSION_free);
	} else {
		RETVAL = 0;
	}

#line 1100 "PKCS10.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_new_from_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_new_from_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, filename_SV");
    {
	SV*	class = ST(0)
;
	SV*	filename_SV = ST(1)
;
#line 744 "PKCS10.xs"
  char* filename;
  STRLEN filename_length;
  FILE* fp;
  X509_REQ *req;

#line 1125 "PKCS10.c"
	SV *	RETVAL;
#line 750 "PKCS10.xs"
  filename = SvPV(filename_SV, filename_length);
  fp = fopen(filename, "r");
  if (fp == NULL) {
          croak ("Cannot open file '%s'", filename);
  }
  req = PEM_read_X509_REQ (fp, NULL, NULL, NULL);
  fclose(fp);

  RETVAL = make_pkcs10_obj(class, req, NULL, NULL, NULL);

#line 1138 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_accessor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__PKCS10_accessor)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkcs10");
    {
	pkcs10Data *	pkcs10;
#line 774 "PKCS10.xs"
  BIO *bio;
  X509_NAME *name;
  EVP_PKEY *key;

#line 1160 "PKCS10.c"
	SV *	RETVAL;

    if (!(SvROK(ST(0)) && sv_derived_from(ST(0), PACKAGE_NAME)))
    {
        croak("argument is not a pkcs10Data * object");
    }
    pkcs10 = (pkcs10Data *) SvIV(SvRV(ST(0)))
;
#line 780 "PKCS10.xs"
  bio = sv_bio_create();

  if (pkcs10->req != NULL) {
    if (ix == 1) {
      name = X509_REQ_get_subject_name(pkcs10->req);
      X509_NAME_print_ex(bio, name, 0, XN_FLAG_SEP_CPLUS_SPC);
    } else if (ix == 2 ) {
      key = X509_REQ_get_pubkey(pkcs10->req);
#if OPENSSL_VERSION_NUMBER >= 0x30000000L
      EVP_PKEY_print_public(bio, key, 0, NULL);
#else
      RSA_print(bio, EVP_PKEY_get1_RSA(key), 0);
#endif
    }
  }

  RETVAL = sv_bio_final(bio);

#line 1188 "PKCS10.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__OpenSSL__PKCS10); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__OpenSSL__PKCS10)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("Crypt::OpenSSL::PKCS10::new", XS_Crypt__OpenSSL__PKCS10_new);
        newXS_deffile("Crypt::OpenSSL::PKCS10::DESTROY", XS_Crypt__OpenSSL__PKCS10_DESTROY);
        newXS_deffile("Crypt::OpenSSL::PKCS10::_new_from_rsa", XS_Crypt__OpenSSL__PKCS10__new_from_rsa);
        newXS_deffile("Crypt::OpenSSL::PKCS10::sign", XS_Crypt__OpenSSL__PKCS10_sign);
        newXS_deffile("Crypt::OpenSSL::PKCS10::get_pem_pubkey", XS_Crypt__OpenSSL__PKCS10_get_pem_pubkey);
        newXS_deffile("Crypt::OpenSSL::PKCS10::pubkey_type", XS_Crypt__OpenSSL__PKCS10_pubkey_type);
        cv = newXSproto_portable("Crypt::OpenSSL::PKCS10::get_pem_req", XS_Crypt__OpenSSL__PKCS10_get_pem_req, file, "$;$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Crypt::OpenSSL::PKCS10::write_pem_req", XS_Crypt__OpenSSL__PKCS10_get_pem_req, file, "$;$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Crypt::OpenSSL::PKCS10::get_pem_pk", XS_Crypt__OpenSSL__PKCS10_get_pem_pk, file, "$;$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Crypt::OpenSSL::PKCS10::write_pem_pk", XS_Crypt__OpenSSL__PKCS10_get_pem_pk, file, "$;$");
        XSANY.any_i32 = 1;
        newXS_deffile("Crypt::OpenSSL::PKCS10::set_subject", XS_Crypt__OpenSSL__PKCS10_set_subject);
        newXS_deffile("Crypt::OpenSSL::PKCS10::add_ext", XS_Crypt__OpenSSL__PKCS10_add_ext);
        newXS_deffile("Crypt::OpenSSL::PKCS10::add_custom_ext_raw", XS_Crypt__OpenSSL__PKCS10_add_custom_ext_raw);
        newXS_deffile("Crypt::OpenSSL::PKCS10::add_custom_ext", XS_Crypt__OpenSSL__PKCS10_add_custom_ext);
        newXS_deffile("Crypt::OpenSSL::PKCS10::add_ext_final", XS_Crypt__OpenSSL__PKCS10_add_ext_final);
        newXS_deffile("Crypt::OpenSSL::PKCS10::new_from_file", XS_Crypt__OpenSSL__PKCS10_new_from_file);
        cv = newXS_deffile("Crypt::OpenSSL::PKCS10::accessor", XS_Crypt__OpenSSL__PKCS10_accessor);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::PKCS10::keyinfo", XS_Crypt__OpenSSL__PKCS10_accessor);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::PKCS10::subject", XS_Crypt__OpenSSL__PKCS10_accessor);
        XSANY.any_i32 = 1;
    }

    /* Initialisation Section */

#line 317 "PKCS10.xs"
{
	/*OpenSSL_add_all_algorithms();
        OpenSSL_add_all_ciphers();
        OpenSSL_add_all_digests();
	ERR_load_PEM_strings();
        ERR_load_ASN1_strings();
        ERR_load_crypto_strings();
        ERR_load_X509_strings();
        ERR_load_DSA_strings();
        ERR_load_RSA_strings();*/
	HV *stash = gv_stashpvn("Crypt::OpenSSL::PKCS10", 22, TRUE);

	struct { char *n; I32 v; } Crypt__OpenSSL__PKCS10__const[] = {

	{"NID_key_usage", NID_key_usage},
	{"NID_subject_alt_name", NID_subject_alt_name},
	{"NID_netscape_cert_type", NID_netscape_cert_type},
	{"NID_netscape_comment", NID_netscape_comment},
	{"NID_ext_key_usage", NID_ext_key_usage},
	{"NID_subject_key_identifier", NID_subject_key_identifier},
	{Nullch,0}};

	char *name;
	int i;

	for (i = 0; (name = Crypt__OpenSSL__PKCS10__const[i].n); i++) {
		newCONSTSUB(stash, name, newSViv(Crypt__OpenSSL__PKCS10__const[i].v));
	}
}

#line 1287 "PKCS10.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
